Package org.apache.storm.trident.spout

## Interface ITridentSpout<T>

- All Superinterfaces:
    `ITridentDataSource`, `Serializable`
  All Known Subinterfaces:
    `ICommitterTridentSpout<X>`
  All Known Implementing Classes:
    `BatchSpoutExecutor`, `FeederBatchSpout`, `FeederCommitterBatchSpout`, `OpaquePartitionedTridentSpoutExecutor`, `PartitionedTridentSpoutExecutor`, `RichSpoutBatchExecutor`, `TridentJmsSpout`

      public interface ITridentSpout<T>
      extends ITridentDataSource

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static interface` | `ITridentSpout.BatchCoordinator<X>` |
    `static interface` | `ITridentSpout.Emitter<X>` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Map<String,​Object>` | `getComponentConfiguration()` |
    `ITridentSpout.BatchCoordinator<T>` | `getCoordinator​(String txStateId, Map<String,​Object> conf, TopologyContext context)` | The coordinator for a TransactionalSpout runs in a single thread and indicates when batches of tuples should be emitted.
    `ITridentSpout.Emitter<T>` | `getEmitter​(String txStateId, Map<String,​Object> conf, TopologyContext context)` | The emitter for a TransactionalSpout runs as many tasks across the cluster.
    `Fields` | `getOutputFields()` |

- - ### Method Detail

    - #### getCoordinator

          ITridentSpout.BatchCoordinator<T> getCoordinator​(String txStateId,
                                                           Map<String,​Object> conf,
                                                           TopologyContext context)

      The coordinator for a TransactionalSpout runs in a single thread and indicates when batches of tuples should be emitted. The Coordinator that you provide in a TransactionalSpout provides metadata for each transaction so that the transactions can be replayed in case of failure.

      Two instances are requested, one on the master batch coordinator where isReady() is called, and an instance in the coordinator bolt which is used for all other operations. The two instances do not necessarily share a worker JVM.

      Parameters:
        `txStateId` - stream id
        `conf` - Storm config map
        `context` - topology context
      Returns:
        spout coordinator instance

    - #### getEmitter

          ITridentSpout.Emitter<T> getEmitter​(String txStateId,
                                              Map<String,​Object> conf,
                                              TopologyContext context)

      The emitter for a TransactionalSpout runs as many tasks across the cluster. Emitters are responsible for emitting batches of tuples for a transaction and must ensure that the same batch of tuples is always emitted for the same transaction id.

      All emitter tasks get the same transaction metadata. The topology context parameter contains the instance task id that can be used to distribute the work across the tasks.

      Parameters:
        `txStateId` - stream id
        `conf` - Storm config map
        `context` - topology context
      Returns:
        spout emitter

    - #### getComponentConfiguration

          Map<String,​Object> getComponentConfiguration()

    - #### getOutputFields

          Fields getOutputFields()